{

  vIRtECH 3d Engine

  Most parts of this source are written by Ansgar Scherp of
  vIRTUAL tECHNOLOGIES. Some procedures are from unknown source. Thanks
  go out to them!

  (c) vIRtECH 1996-1998


  Extensions:
   .WRL --> a 3d World
   .CON --> construct; composition of several objects
   .OBJ --> an objekt (cubes, dots etc.)


  If you like the _VIDEO13.PAS, _VIDEOHI, _BIGLOAD or
  _KBDHAND Unit, please have a look at our homepage and
  download the lastet versions of our toolkits.

  This sourcecode has been released under the GNU General Public License.

  For any questions, comments, donations contact me:

  Ansgar Scherp
  Ansgar.Scherp@Informatik.Uni-Oldenburg.DE
  http://www.Informatik.Uni-Oldenburg.DE/~virtech/

}

{$N+,E+}  { we need this, because we use reals... :-( }

uses
  crt, Dos, _Math3d , _Frame, _DPMI, _BigLoad, _Video3d,
  _Video13, _VideoHi, _KBDHand;

var
 WritePage     : TPage;
 WritePage101h : TPage101h;

 MyWorld : PWorld3D;

 Name,
 PalName : string;
 Pal     : TPal;

 i :LongInt;
 VideoMode : word;

procedure CheckParameters;
  var a : byte;
begin
  if (ParamStr(1) = '-?') or (ParamStr(1) = '/?') or
     (ParamStr(1) = '?') then
    begin
      writeln;
      writeln(' Executing vIRtECHs 3dim-Viewer as following:');
      writeln(' VIEWER.EXE <world-name> [palette-name]');
      writeln(' <> - must, [] and extensions are optional');
      writeln;
      halt(0);
    end;
  {}
  Name := ParamStr(1);
  if ParamCount < 1 then Name := 'CHESSWRL';
  for a := 0 to length(name) do
    name[a] := upcase(name[a]);
  if name <> '' then
    if pos('.WRL', Name) = 0 then Name := Name + '.WRL';
  {}
  PalName := ParamStr(2);
  if ParamCount < 1 then PalName := 'YELLOW';
  if PalName = '' then PalName := 'STANDARD';
  for a := 0 to length(PalName) do
    PalName[a] := upcase(PalName[a]);
  if PalName <> '' then
    if pos('.PAL', PalName) = 0 then PalName := PalName + '.PAL';
end;

procedure InitAll;
var x:word;
begin
  InitVideo101h;
  InitVideo13h;
  FileMode := 0;
  textmode(co80+Font8x8);
  LastMode := co80;
  textbackground(black); clrscr;
  textcolor(white); textbackground(blue);
  write(' Virtual Worlds 101h and 13h V 3.0  (c) Ansgar Scherp, Joachim Gelhaus / VT''95 ');
  textbackground(black);
  window(1,2,80,43);
  writeln;
  writeln('  ----------------------------------------------------------------------------  ');
  writeln('         ATTENTION : THIS 3d-VIEWER IS FREEWARE! It''s a research version.  ');
  Textcolor(LightRed+Blink);
  writeln('        SO PLEASE COPY IT TO ALL YOUR FRIENDS AND DOWNLOAD IT TO ALL BBSs!      ');
  textcolor(white);
  writeln('  ----------------------------------------------------------------------------  ');
  InitPage(WritePage);
  InitPage101h(WritePage101h);
  InitFrameHandler;
  InitKBDHandler;
  {}
  DisplayVideo3DInfo;
  write('Press any key to continue...');
  ReadKey;

  clrscr; writeln;
  Writeln('Loading ',PalName,' ...');
  LoadPalette( PalName, Pal );
  Writeln('Loading ',Name,' ...');
  LoadWorld3D( MyWorld, Name);

  DisplayWorldInfo( MyWorld );
  writeln;
  writeln('Controls:'); writeln;
  writeln('-German Keyboard-------------------------------------------------------------');
  writeln('  Cursor  -> walk around in the world (with shift : move faster');
  writeln('  Y/X     -> move viewers point up/down');
  writeln('  Z       -> Zoom camera FORWARD');
  writeln('  Z+Shift -> Zoom camera BACKWARD');
  writeln('  1       -> Set Video Mode  13h (320x200x256)');
  writeln('  2       -> Set Video Mode 101h (640x480x256) (requires VESA 2.0; pre-set)');
  writeln('-----------------------------------------------------------------------------');
  writeln;
  writeln('-English Keyboard------------------------------------------------------------');
  writeln('  Cursor  -> walk around in the world (with shift : move faster');
  writeln('  Z/X     -> move viewers point up/down');
  writeln('  Y       -> Zoom camera FORWARD');
  writeln('  Y+Shift -> Zoom camera BACKWARD');
  writeln('  1       -> Set Video Mode  13h (320x200x256)');
  writeln('  2       -> Set Video Mode 101h (640x480x256) (requires VESA 2.0; pre-set)');
  writeln('-----------------------------------------------------------------------------');
  writeln;
  write('Press any key to start... ');
  {
  for i := 0 to MyWorld^.ObjectCounter-1 do
    writeln( 'No/Name: ', i :3, '/', MyWorld^.ObjectList^[i].FileName );
  {}
  readkey;
  ResetFrames;
  SetVideoMode101h($101);
  SetPalette( Pal );
  VideoMode := Mode101h;
  MyWorld^.DeltaX := 320;
  MyWorld^.DeltaY := 240;
end;

procedure CloseAll;
begin
  CloseKBDHandler;
  CloseFrameHandler;
  CloseWorld3D(MyWorld);
  ClosePage(WritePage);
  ClosePage101h(WritePage101h);
  CloseVideo13h;
  Textmode(3);
  Writeln('Thanks for testing our 3dviewer!');
  writeln;
  writeln('vIRTUAL tECHNOLOGIES');
  writeln('Hotline : +49 (0)4441-851717');
  writeln('Mailbox : +49 (0)4441-851887');
  writeln('WWW     : http://www.informatik.uni-oldenburg.de/~virtech/');
  writeln('Email   : scherp.ansgar@arbi.informatik.uni-oldenburg.de');
  writeln;
  writeln('(c) vIRtECH 1995-1996');
  writeln;
end;

procedure DrawWorld;
begin
  {grafikroutinen fuer 13h}
  if VideoMode = Mode13h then
    begin
      ClearPage(WritePage);
      DrawWorld3D(MyWorld);
      CopyP2V(writepage);
    end;
  {grafikroutinen fuer 101h}
  if VideoMode = Mode101h then
    begin
      ClearPage101h(WritePage101h);
      DrawWorld3D101h(MyWorld);
      CopyP2V101h(writepage101h);
    end;
end;

procedure ChangeMode;
begin
  {wechseln des Modus}
  if (key[k1] = 1) and (VideoMode <> Mode13h) then
    begin
      SetVideoMode101h($13);
      VideoMode := Mode13h;
      ActivePage(WritePage);
      SetPalette( Pal );
      SetWindow(0,0,319,199);
      MyWorld^.DeltaX := 160;
      MyWorld^.DeltaY := 100;
      MyWorld^.Tra[Z] := MyWorld^.Tra[Z] * 2;
    end;
  if (key[k2] = 1) and (VideoMode <> Mode101h) then
    begin
      SetVideoMode101h($101);
      VideoMode := Mode101h;
      ActivePage101h(WritePage101h);
      SetPalette( Pal );
      SetWindow101h(0,0,639,479);
      MyWorld^.DeltaX := 320;
      MyWorld^.DeltaY := 240;
      MyWorld^.Tra[Z] := MyWorld^.Tra[Z] div 2;
    end;
end;


var
  Add : T3D;

begin
  CheckParameters;
  InitAll;

  MyWorld^.EleminationDistance := 50;

  Add[x] := 5 * PointAdj;
  Add[y] := 0 * PointAdj;
  Add[z] := 0 * PointAdj;

  while key[kESC] = 0 do
    begin
      RotateWorld3D( MyWorld );

      DrawWorld;

      { Steroscopic }
      {
      MyWorld^.Tra[X] := MyWorld^.Tra[X] + 2 * PointAdj;
      RotateWorld3D(MyWorld );
      DrawWorld;
      MyWorld^.Tra[X] := MyWorld^.Tra[X] - 2 * PointAdj;
      {}

      GetPlayerOrders(MyWorld, 5, 10, 5, 5, 5, 0.1 );

      DirectTraRelObject( MyWorld, 0 , Add );

      with MyWorld^ do
        if ( VectorList^[ ObjectList^[0].StartVector ][x] > 100*PointAdj) or
           ( VectorList^[ ObjectList^[0].StartVector ][x] < -100*PointAdj )
           then Add[x] := - Add[x];

      ChangeMode;
    end;
 CloseAll;
end.
