;
; Vector math assembler modul
;
  TITLE _MATH.ASM

  MODEL SMALL

  IDEAL
  NOJUMPS
  LOCALS @@

  DATASEG
    SinTable \
      DW 00000h, 00006h, 0000Dh, 00013h, 00019h, 0001Fh, 00026h, 0002Ch, 00032h, 00038h, 0003Fh, 00045h, 0004Bh, 00051h, 00058h, 0005Eh
      DW 00064h, 0006Ah, 00070h, 00076h, 0007Ch, 00082h, 00089h, 0008Fh, 00095h, 0009Bh, 000A1h, 000A7h, 000ACh, 000B2h, 000B8h, 000BEh
      DW 000C4h, 000CAh, 000CFh, 000D5h, 000DBh, 000E1h, 000E6h, 000ECh, 000F1h, 000F7h, 000FCh, 00102h, 00107h, 0010Dh, 00112h, 00117h
      DW 0011Ch, 00122h, 00127h, 0012Ch, 00131h, 00136h, 0013Bh, 00140h, 00145h, 0014Ah, 0014Eh, 00153h, 00158h, 0015Ch, 00161h, 00166h
      DW 0016Ah, 0016Eh, 00173h, 00177h, 0017Bh, 00180h, 00184h, 00188h, 0018Ch, 00190h, 00194h, 00197h, 0019Bh, 0019Fh, 001A3h, 001A6h
      DW 001AAh, 001ADh, 001B1h, 001B4h, 001B7h, 001BAh, 001BDh, 001C1h, 001C4h, 001C6h, 001C9h, 001CCh, 001CFh, 001D1h, 001D4h, 001D7h
      DW 001D9h, 001DBh, 001DEh, 001E0h, 001E2h, 001E4h, 001E6h, 001E8h, 001EAh, 001ECh, 001EDh, 001EFh, 001F1h, 001F2h, 001F4h, 001F5h
      DW 001F6h, 001F7h, 001F8h, 001F9h, 001FAh, 001FBh, 001FCh, 001FDh, 001FEh, 001FEh, 001FFh, 001FFh, 001FFh, 00200h, 00200h, 00200h
      DW 00200h

  CODESEG

  PUBLIC ZeroVec3D
  PUBLIC LInt2Vec3D
  PUBLIC Vec3D2LInt
  PUBLIC VecAdd3D
  PUBLIC VecSub3D
  PUBLIC VecDot3D
  PUBLIC VecCross3D
  PUBLIC VecScalMul3D

  PUBLIC ZeroMatrix
  PUBLIC TransformVecMatrix
  PUBLIC RotateMatrix
  PUBLIC CreateMatrix

  PUBLIC VecAdd2D
  PUBLIC VecSub2D

  EXTRN PointAdj : DWORD

  P386N

;----------------------------------------------------------------------------
; function FixSin(bx) :eax;
;----------------------------------------------------------------------------
  PROC FixSin NEAR
       and    bx,1FFh
       cmp    bx,256
       jge    @@21
       cmp    bx,128
       jng    @@11
       neg    bx
       add    bx,256
  @@11:
       shl    bx,1
       mov    ax,[bx+SinTable]
       cwde
       ret
  @@21:
       sub    bx,256
       cmp    bx,128
       jnge   @@22
       neg    bx
       add    bx,256
  @@22:
       shl    bx,1
       mov    ax,[bx+SinTable]
       neg    ax
       cwde
       ret
  ENDP

;----------------------------------------------------------------------------
; function FixCos(bx) :eax;
;----------------------------------------------------------------------------
  PROC FixCos NEAR
       add    bx,128
       jmp    FixSin
  ENDP

;
; procedure ZeroVec3D(var C :T3D);
;
  PROC ZeroVec3D FAR
       ARG C:DWord = @@return
       enter  0,0
       cld
       les    di,[C]
       xor    eax,eax
       stosd
       stosd
       stosd
       leave
       ret    @@return
  ENDP

;
; procedure LInt2Vec3D(vx,vy,vz :LongInt; var C :T3D);
;
  PROC LInt2Vec3D FAR
       ARG C:DWord, vz:DWord, vy:DWord, vx:DWord = @@return
       enter  0,0
       cld
       les    di,[C]
       mov    eax,[vx]
       stosd
       mov    eax,[vy]
       stosd
       mov    eax,[vz]
       stosd
       leave
       ret    @@return
  ENDP

;
; procedure Vec3D2LInt(A :T3D; var vx,vy,vz :LongInt);
;
  PROC Vec3D2LInt FAR
       ARG vz:DWord, vy:DWord, vx:DWord, A:DWord = @@return
       enter  0,0
       cld
       push   ds
       lds    si,[A]
       lodsd
       les    di,[vx]
       mov    [es:di],eax
       lodsd
       les    di,[vy]
       mov    [es:di],eax
       lodsd
       les    di,[vz]
       mov    [es:di],eax
       pop    ds
       leave
       ret    @@return
  ENDP

;
; procedure VecAdd3D(A,B :T3D; var C :T3D);
;
  PROC VecAdd3D FAR
       ARG C:DWord, B:DWord, A:DWord = @@return
       enter  0,0
       cld
       push   ds
       lds    si,[A]
       lgs    bx,[B]
       les    di,[C]
       lodsd
       add    eax,[gs:bx]
       stosd
       lodsd
       add    eax,[gs:bx+4]
       stosd
       lodsd
       add    eax,[gs:bx+8]
       stosd
       pop    ds
       leave
       ret    @@return
  ENDP

;
; procedure VecSub3D(A,B :T3D; var C :T3D);
;
  PROC VecSub3D FAR
       ARG C:DWord, B:DWord, A:DWord = @@return
       enter  0,0
       cld
       push   ds
       lds    si,[A]
       lgs    bx,[B]
       les    di,[C]
       lodsd
       sub    eax,[gs:bx]
       stosd
       lodsd
       sub    eax,[gs:bx+4]
       stosd
       lodsd
       sub    eax,[gs:bx+8]
       stosd
       pop    ds
       leave
       ret    @@return
  ENDP

;
; function VecDot3D(A,B :T3D) :LongInt;
;
  PROC VecDot3D FAR
       ARG B:DWord, A:DWord = @@return
       enter  0,0
       push   ds
       lds    si,[A]
       les    di,[B]
       lodsd
       imul   [DWORD PTR es:di+4]
       shrd   eax,edx,9
       mov    ecx,eax
       lodsd
       imul   [DWORD PTR es:di+4]
       shrd   eax,edx,9
       add    ecx,eax
       lodsd
       imul   [DWORD PTR es:di+8]
       shrd   eax,edx,9
       add    ecx,eax
       mov    ax,cx
       rol    ecx,16
       mov    dx,cx
       pop    ds
       leave
       ret    @@return
  ENDP

;
; procedure VecCross3D(A,B :T3D; var C :T3D);
;
  PROC VecCross3D FAR
       ARG C:DWord, B:DWord, A:DWord = @@return
       enter  0,0
       push   ds
       lds    si,[A]
       les    di,[B]
       lgs    bx,[C]
       mov    eax,[si+4]
       imul   [DWORD PTR es:di+8]
       shrd   eax,edx,9
       mov    ecx,eax
       mov    eax,[si+8]
       imul   [DWORD PTR es:di+4]
       shrd   eax,edx,9
       sub    ecx,eax
       mov    [gs:bx],ecx
       mov    eax,[si+8]
       imul   [DWORD PTR es:di]
       shrd   eax,edx,9
       mov    ecx,eax
       mov    eax,[si]
       imul   [DWORD PTR es:di+8]
       shrd   eax,edx,9
       sub    ecx,eax
       mov    [gs:bx+4],ecx
       mov    eax,[si]
       imul   [DWORD PTR es:di+4]
       shrd   eax,edx,9
       mov    ecx,eax
       mov    eax,[si+4]
       imul   [DWORD PTR es:di]
       shrd   eax,edx,9
       sub    ecx,eax
       mov    [gs:bx+8],ecx
       pop    ds
       leave
       ret    @@return
  ENDP

;
; procedure VecScalMul3D(k :LongInt; A :T3D; var C :T3D);
;
  PROC VecScalMul3D FAR
       ARG C:DWord, A:DWord, k:DWord = @@return
       enter  0,0
       push   ds
       lds    si,[A]
       les    di,[C]
       lodsd
       imul   [k]
       shrd   eax,edx,9
       stosd
       lodsd
       imul   [k]
       shrd   eax,edx,9
       stosd
       lodsd
       imul   [k]
       shrd   eax,edx,9
       stosd
       pop    ds
       leave
       ret    @@return
  ENDP

;
; procedure ZeroMatrix(var C :TMatrix);
;
  PROC ZeroMatrix FAR
       ARG C :DWord = @@return
       enter  0,0
       les    di,[C]
       xor    eax,eax
       mov    cx,(4*4*4)/4
       repne  stosd
       leave
       ret    @@return
  ENDP

;
; procedure TransformVecMatrix(A :T3D; M :TMatrix; var C :T3D);
;
  PROC TransformVecMatrix FAR
       ARG C:DWord, M:DWord, A:DWord = @@return
       enter  0,0
       lfs    si,[A]
       lgs    bx,[M]
       les    di,[C]
       mov    cx,3
  @@11:
       push   cx
       mov    eax,[fs:si]
       imul   [DWORD PTR gs:bx]
       shrd   eax,edx,9
       mov    ecx,eax
       mov    eax,[fs:si+4]
       imul   [DWORD PTR gs:bx+4]
       shrd   eax,edx,9
       add    ecx,eax
       mov    eax,[fs:si+8]
       imul   [DWORD PTR gs:bx+8]
       shrd   eax,edx,9
       add    ecx,eax
       add    ecx,[DWORD PTR gs:bx+12]
       mov    [es:di],ecx
       add    di,4
       add    bx,16
       pop    cx
       loop   @@11
       leave
       ret    @@return
  ENDP

;
; procedure RotateMatrix(rx,ry,rz :Integer; var R :TMatrix);
;
  PROC RotateMatrix FAR
       ARG R:DWord, rz:Word, ry:Word, rx:Word = @@return
       LOCAL SinX:DWord,SinY:DWord,SinZ:DWord,CosX:DWord,CosY:DWord,CosZ:DWord,A:DWord,B:DWord = @@local
       enter  @@local,0

       les    di,[R]       ; ok, ES:DI auf Matrix zeigen lassen und lschen
       push   di
       mov    cx,(4*4*4)/4
       xor    eax,eax
       repne  stosd
       pop    di

       mov    bx,[rx]      ; Sinus & Cosinus von rx berechnen
       call   FixSin
       mov    [SinX],eax
       mov    bx,[rx]
       call   FixCos
       mov    [CosX],eax

       mov    bx,[ry]      ; Sinus & Cosinus von ry berechnen
       call   FixSin
       mov    [SinY],eax
       mov    bx,[ry]
       call   FixCos
       mov    [CosY],eax

       mov    bx,[rz]      ; Sinus & Cosinus von rz berechnen
       call   FixSin
       mov    [SinZ],eax
       mov    bx,[rz]
       call   FixCos
       mov    [CosZ],eax

       imul   [SinY]
       shrd   eax,edx,9
       mov    [A],eax      ; A := CosZ*SinY

       mov    eax,[SinZ]
       imul   [SinY]
       shrd   eax,edx,9
       mov    [B],eax      ; B := SinZ*SinY

       mov    eax,[CosZ]
       imul   [CosY]
       shrd   eax,edx,9
       mov    [es:di],eax  ; ersten eintrag sichern; CosZ*CosY

       mov    eax,[A]
       imul   [SinX]        ; eax = SinX*A
       shrd   eax,edx,9
       mov    ebx,eax       ; ebx = eax
       mov    eax,[SinZ]
       imul   [CosX]        ; eax = SinZ*CosX
       shrd   eax,edx,9
       sub    ebx,eax       ; ebx = ebx - eax
       mov    [es:di+4],ebx ; ( ebx = SinX*A - SinZ*CosX )

       mov    eax,[A]
       imul   [CosX]
       shrd   eax,edx,9
       mov    ebx,eax        ; ebx = CosX*A
       mov    eax,[SinZ]
       imul   [SinX]         ; eax = SinX*SinZ
       shrd   eax,edx,9
       add    eax,ebx        ; eax = eax + ebx
       mov    [es:di+8],eax  ; ( eax = SinX*SinZ + CosX*A)

       mov    eax,[SinZ]
       imul   [CosY]
       shrd   eax,edx,9
       mov    [es:di+16],eax ; ( SinZ*CosY )

       mov    eax,[B]
       imul   [SinX]
       shrd   eax,edx,9
       mov    ebx,eax         ; ebx = B*SinX
       mov    eax,[CosZ]
       imul   [CosX]
       shrd   eax,edx,9       ; eax = CosX*CosZ
       add    eax,ebx         ; eax = eax + ebx
       mov    [es:di+20],eax  ; ( eax = CosX*CosZ + B*SinX )

       mov    eax,[B]
       imul   [CosX]
       shrd   eax,edx,9
       mov    ebx,eax         ; ebx = B*CosX
       mov    eax,[CosZ]
       imul   [SinX]
       shrd   eax,edx,9       ; eax = SinX*CosZ
       sub    ebx,eax         ; ebx = ebx - eax
       mov    [es:di+24],ebx  ; ( ebx = B*CosX - SinX*CosZ )

       mov    eax,[SinY]
       neg    eax
       mov    [es:di+32],eax  ; ( eax = -SinY )

       mov    eax,[CosY]
       imul   [SinX]
       shrd   eax,edx,9
       mov    [es:di+36],eax  ; ( eax = CosY*SinX )

       mov    eax,[CosY]
       imul   [CosX]
       shrd   eax,edx,9
       mov    [es:di+40],eax  ; ( eax = CosY*CosX )

       mov    eax,[PointAdj]
       mov    [es:di+60],eax
       leave
       ret    @@return
  ENDP

;
; procedure CreateMatrix(tx,ty,tz, sx,sy,sz, rx,ry,rz :Integer; var M :TMatrix);
;
  PROC CreateMatrix FAR

       ARG M:DWord, rz:Word, ry:Word, rx:Word, sz:DWord, sy:DWord, sx:DWord, tz:DWord, ty:DWord, tx:DWord = @@return

       LOCAL SinX:DWord,SinY:DWord,SinZ:DWord,CosX:DWord,CosY:DWord,CosZ:DWord,A:DWord,B:DWord = @@local
       enter  @@local,0

       les    di,[M]        ; [ES:DI] auf Matrix zeigen lassen
       push   di
       mov    cx,(4*4*4)/4
       xor    eax,eax
       repne  stosd         ; Matrix lschen
       pop    di

       mov    bx,[rx]
       call   FixSin        ; von rx den sinus berechnen
       mov    [SinX],eax    ; und in SinX sichern
       mov    bx,[rx]
       call   FixCos        ; von rx den cosinus berechnen
       mov    [CosX],eax    ; und in CosX ablegen

       mov    bx,[ry]
       call   FixSin        ; von ry den sinus berechnen
       mov    [SinY],eax    ; und in SinY sichern
       mov    bx,[ry]
       call   FixCos        ; von ry den cosinus berechnen
       mov    [CosY],eax    ; und in CosY sichern

       mov    bx,[rz]
       call   FixSin        ; von rz den sinus berechnen
       mov    [SinZ],eax    ; und in SinZ sichern
       mov    bx,[rz]
       call   FixCos        ; von rz den cosinus berechnen
       mov    [CosZ],eax    ; und in CosZ sichern

       imul   [SinY]        ; eax mit SinY mal nehmen
       shrd   eax,edx,9
       mov    [A],eax       ; A = SinY*CosZ

       mov    eax,[SinZ]
       imul   [SinY]
       shrd   eax,edx,9
       mov    [B],eax       ; B = SinZ*SinY

       mov    eax,[CosZ]
       imul   [CosY]
       shrd   eax,edx,9     ; eax = CosZ*CosY
       imul   [sx]          ; eax = eax*sx
       shrd   eax,edx,9
       mov    [es:di],eax   ; ( eax = CosZ*CosY*sx )

       mov    eax,[SinZ]
       imul   [CosX]
       shrd   eax,edx,9
       mov    ebx,eax       ; ebx = CosX*SinZ
       mov    eax,[A]
       imul   [SinX]
       shrd   eax,edx,9
       sub    eax,ebx       ; eax = SinX*A
       imul   [sx]          ; eax = eax*sx
       shrd   eax,edx,9
       mov    [es:di+4],eax ; ( eax = SinX*A*sx );

       mov    eax,[A]
       imul   [CosX]
       shrd   eax,edx,9
       mov    ebx,eax        ; ebx = CosX*A
       mov    eax,[SinZ]
       imul   [SinX]
       shrd   eax,edx,9      ; eax = SinZ*SinX
       add    eax,ebx        ; eax = eax + ebx
       imul   [sx]           ; eax = eax * sx
       shrd   eax,edx,9
       mov    [es:di+8],eax  ; ( eax = ( SinZ*SinX + CosX*A ) * sx )

       mov    eax,[SinZ]
       imul   [CosY]
       shrd   eax,edx,9      ; eax = SinZ*CosY
       imul   [sy]           ; eax = eax*sy
       shrd   eax,edx,9
       mov    [es:di+16],eax ; ( eax = SinZ*CosY*sy )

       mov    eax,[B]
       imul   [SinX]
       shrd   eax,edx,9
       mov    ebx,eax        ; ebx = SinX*B
       mov    eax,[CosZ]
       imul   [CosX]
       shrd   eax,edx,9      ; eax = CosZ*CosX
       add    eax,ebx        ; eax = eax + ebx
       imul   [sy]           ; eax = eax * sy
       shrd   eax,edx,9
       mov    [es:di+20],eax ; ( eax = ( CosZ*CosX + SinX*B ) * sy )

       mov    eax,[CosZ]
       imul   [SinX]
       shrd   eax,edx,9
       mov    ebx,eax        ; ebx = CosZ*SinX
       mov    eax,[B]
       imul   [CosX]
       shrd   eax,edx,9      ; eax = CosX*B
       sub    eax,ebx        ; eax = eax - ebx
       imul   [sy]           ; eax = eax*sy
       shrd   eax,edx,9
       mov    [es:di+24],eax ; ( eax = ( CosX*B - CosZ*SinX )*sy )

       mov    eax,[SinY]
       neg    eax              ; eax = - SinY
       imul   [sz]             ; eax = eax*sz
       shrd   eax,edx,9
       mov    [es:di+32],eax   ; ( eax = -SinY*sz )

       mov    eax,[CosY]
       imul   [SinX]
       shrd   eax,edx,9        ; eax = SinX*CosY
       imul   [sz]             ; eax = eax*sz
       shrd   eax,edx,9
       mov    [es:di+36],eax   ; ( eax = SinX*CosY*sz )

       mov    eax,[CosY]
       imul   [CosX]
       shrd   eax,edx,9        ; eax = CosY*CosX
       imul   [sz]             ; eax = eax*sz
       shrd   eax,edx,9
       mov    [es:di+40],eax   ; ( eax = CosY*CosX*sz )

       mov    eax,[tx]
       imul   [sx]             ; eax = tx*sx
       shrd   eax,edx,9
       mov    [es:di+12],eax   ; ( eax = tx*sx)

       mov    eax,[ty]
       imul   [sy]             ; eax = ty*sy
       shrd   eax,edx,9
       mov    [es:di+28],eax   ; ( eax = ty*sy)

       mov    eax,[tz]
       imul   [sz]             ; eax = tz*sz
       shrd   eax,edx,9
       mov    [es:di+44],eax   ; ( eax = tz*sz )

       mov    eax, [PointAdj]
       mov    [es:di+60],eax   ;

       leave
       ret    @@return
  ENDP

;
; procedure VecAdd2D(A,B :T2D; var C :T2D);
;
  PROC VecAdd2D FAR
       ARG C:DWord, B:DWord, A:DWord = @@return
       enter  0,0
       les    di,[C]
       mov    ax,[WORD PTR A]
       add    ax,[WORD PTR B]
       stosw
       mov    ax,[WORD PTR A+2]
       add    ax,[WORD PTR B+2]
       stosw
       leave
       ret    @@return
  ENDP

;
; procedure VecSub2D(A,B :T2D; var C :T2D);
;
  PROC VecSub2D FAR
       ARG C:DWord, B:DWord, A:DWord = @@return
       enter  0,0
       les    di,[C]
       mov    ax,[WORD PTR A]
       sub    ax,[WORD PTR B]
       stosw
       mov    ax,[WORD PTR A+2]
       sub    ax,[WORD PTR B+2]
       stosw
       leave
       ret    @@return
  ENDP
  END


