{ vector-math-unit / 32bit / protected mode
  (c) vIRTUAL tECHNOLOGIES Ansgar Scherp, Joachim Gelhaus

  1.1 - verbesserte syntax; kommentare eingefuegt
  1.2 - trefendere Bezeichner gewhlt
  1.3 - PointAdj nun hier drin, wird in Mathe.asm als EXTRN gefhrt

}

unit _Math3d;

interface

const  x = 0;
       y = 1;
       z = 2;

{ interne Speicherung der Zahlen in 32Bit; mit PointAdj = $200 entspricht
  9bit, d.h. 9bit werden fr den Nachkommateil belegt}
var
  PointAdj : longint;

type

  {ein 2D-punkt}
  P2D = ^T2D;
  T2D = array[x..y] of longint;

  {ein 2D-punkt}
  P2Dinteger  = ^T2D;
  T2Dinteger = array[x..y] of integer;

  {ein 2D-punkt}
  P2DRecordInteger = ^T2D;
  T2DRecordInteger =
    record
      x,y : integer;
    end;

  {ein 3D-punkt}
  P3D = ^T3D;
  T3D = array[x..z] of LongInt;
  {ein 3D-punkt}
  P3Dinteger = ^T3Dinteger;
  T3Dinteger = array[x..z] of integer;

  {zeiger auf eine 3x3 Matrix T LongInt}
  PMatrix = ^TMatrix4x4;
  TMatrix4x4 = array[0..3, 0..3] of LongInt;

procedure VecAdd2D(A,B : T2D; var C : T2D);
procedure VecSub2D(A,B : T2D; var C : T2D);

procedure ZeroVec3D(var C : T3D);

procedure LInt2Vec3D(vx,vy,vz :LongInt; var C : T3D);
procedure Vec3D2LInt(A : T3D; var vx,vy,vz :LongInt);

procedure VecAdd3D(A,B : T3D; var C : T3D);
procedure VecSub3D(A,B : T3D; var C : T3D);
function VecDot3D(A,B : T3D) :LongInt;
procedure VecCross3D(A,B : T3D; var C : T3D);
procedure VecScalMul3D(k :LongInt; A : T3D; var C : T3D);

procedure ZeroMatrix(var C : TMatrix4x4);
procedure TransformVecMatrix(A : T3D; M : TMatrix4x4; var C : T3D);
procedure RotateMatrix(rx,ry,rz :Integer; var R : TMatrix4x4);

procedure CreateMatrix(tx,ty,tz, sx,sy,sz : Longint; rx,ry,rz :Integer; var M : TMatrix4x4);

implementation

procedure VecAdd2D(A,B : T2D; var C : T2D); external;
procedure VecSub2D(A,B : T2D; var C : T2D); external;

procedure ZeroVec3D(var C : T3D); external;
procedure LInt2Vec3D(vx,vy,vz :LongInt; var C : T3D); external;
procedure Vec3D2LInt(A : T3D; var vx,vy,vz :LongInt); external;
procedure VecAdd3D(A,B : T3D; var C : T3D); external;
procedure VecSub3D(A,B : T3D; var C : T3D); external;
function VecDot3D(A,B : T3D) :LongInt; external;
procedure VecCross3D(A,B : T3D; var C :T3D); external;
procedure VecScalMul3D(k :LongInt; A : T3D; var C :T3D); external;

procedure ZeroMatrix(var C : TMatrix4x4); external;
procedure TransformVecMatrix(A : T3D; M : TMatrix4x4; var C : T3D); external;
procedure RotateMatrix(rx,ry,rz :Integer; var R : TMatrix4x4); external;

{erzeugt eine 4x4 Matrix mit den angegebenen Werten }
procedure CreateMatrix(tx,ty,tz, sx,sy,sz : Longint; rx,ry,rz :Integer; var M : TMatrix4x4); external;

{$L _MATH3d.OBJ}

begin
  PointAdj := $200;
end.
