{ _VIDEO3D.PAS (c) vIRTUAL tECHNOLOGIES 1995/1996
  Written by Ansgar Scherp of vIRtECH

1.0 Bis zur cebit ' 96
1.1 FinalScalingX/Y/Z und anderes...
1.2 Nun engine ala doom
1.3 Routinen fr Rotation & Translation von einzelnen Objecten eingebaut...

 }

{$N+,E+}

{$DEFINE CheckGouraud3Edges   } { sort the borders of gourad-objects?  }
{$DEFINE CheckGouraud4Edges   } { sort the borders of gourad-objects?  }

{ PseudoTextures currently cause a crash of the program sometimes }

{$DEFINE EnablePseudoTextures } { enables/disables Pseudotextures; the
                                  normal and the transparent ones      }


unit _Video3d;


interface

uses _Math3d, _Video13, _VideoHi;

const
  {maximale Anzahl der Vectoren einer Welt}
  MaxVec3D    = 5000;
  MaxVec2D    = MaxVec3D;
  {maximale Anzahl an Elementen (Punkte/Linien/Polygone) in der Welt}
  MaxElement  = 4000;
  {maximale Anzahl der Objekte dieser Welt}
  MaxObject3D = 500;
  {maximale Anzahl an Ecken, die ein Objekt haben kann!!!}
  MaxEdges    = 4;
  {maximale Anzahl an Texturen}
  MaxTextures = 20; { derzeit auf 255 beschrnkt}

type
  { die verschiedenen ElementTypen }
  TElement =
    ( Point, NormLine, Triangle, Rectangle,
      Texture,
      TextureTrans, { currently not available }
      PseudoTexture,
      PseudoTextureTrans, { currently not available }
      LightGouraud, {gibt es nnoch nicht!!! Gouraud mit Lichteffekten}
      Gouraud
    );
  { die verschiedenen Abhngigkeitstufen der Objecte }
  TDependence  =
    ( NoDependence, { keinerlei Abhngigkeiten }
      WorldTra, WorldRot, WorldTraRot,
      HeadTra, HeadRot, HeadTraRot );

  PElementInhalt = ^TElementInhalt;
  TElementInhalt =
    record
      Typ    : TElement;
      Number : array[0..MaxEdges-1] of integer;
      Color  : array[0..MaxEdges-1] of byte;
      Count  : byte; {anzahl an ecken!}
    end;

  {zeiger auf eine Liste von 3D-Punkten}
  P3DList = ^T3DList;
  T3DList = array[0..MaxVec3D-1] of T3D;

  {zeiger auf eine Liste von 3D-Punkten}
  P2DList = ^T2DList;
  T2DList = array[0..MaxVec2D-1] of T2D;

  {zeiger auf eine Liste von Elementen}
  PtrElementList = ^TElementList;
  TElementList = array[0..MaxElement-1] of
                     {wenn's wirklich nicht mehr geht, dann als PTREle...}
                     TElementInhalt;
  {zeiger auf die z-Werte eines Elements}
  PtrElementZEntry   = ^TElementZEntry;
  ElementZentry = record
                    z         : LongInt; {z-value of Element}
                    Reference : longint; {Reference auf die nummer des Elements !}
                  end;
  TElementZentry = array[0..MaxElement-1] of ElementZEntry;


  {Object3D}
  Object3D =
    record
      {Translations und Rotationswerte des Objektes}
      Tra : T3D;
      Rot : T3Dinteger;

      FileName : String[40];  { filename }
      Name     : string[40];  { name you can give each object }

      StartVector  : Longint;
      EndVector    : Longint;
      StartElement : Longint;
      EndElement   : Longint;
      Dependence : TDependence;
    end;
  {zeiger auf eine ObjectList}
  PtrObject3DList = ^TObject3DList;
  TObject3DList = ARRAY [0..MaxObject3D-1] of Object3D;

  TTexture =
    record
      Data     : TSprite;
      FileName : String[40];
    end;

  PTextureList = ^TTextureList;
  TTextureList = array[0..MaxTextures-1] of TTexture;

  PWorld3D = ^TWorld3D;
  TWorld3D =
    record
      VectorCounter : LongInt; {Zhler fr die Vektoren}
      VectorList    : P3DList; {Liste der eingelesenen Vektoren}
      TransList     : P3DList; {Liste der transformierten Vektoren}
      Point2DList   : P2DList; {Liste der 2D umgerechneten Vektoren }
      {}
      ObjectCounter : Longint; {zhlt die einzelnen objekte}
      ObjectList    : PtrObject3DList;
      {}
      ElementCounter    : LongInt; {Zhler fr die Elemente}
      ElementList       : PtrElementList; {Liste zeichnenden Punkt}
      ElementZEntryList : PtrElementZEntry; {Liste der Z - Eintrger der Polygone }

      TextureCounter : Word;
      TextureList    : PTextureList; {TextureList}


      { Translation (Verschiebungen) des Objektes;
        Die Werte fr die Translation sind wie folgt aufgebaut:
        z.B.: Translation num 10 Pixel nach rechts, als das Original:
          TraX := 10 * PointAdj;
        Die Werte von TraX,TraY,TraZ stellen die absoluten
        Translationswerte dar }
      Tra : T3D;
      { Rotationsschritt: 0-360 = 0-PointAdj
        bei PointAdj = $200 = 512 also: 0.7-Schritte;
        Die Werte von RotX,RotY,RotZ stellen die absoluten
        Rotationswerte dar }
      Rot : T3Dinteger;
      { Hier kann ein Skalierungsfaktor fr die gesammte Welt angegeben
        werden. 1 = 100%; 2 = 200%; 0.5 = 50% }

      { Verschiebung des Bildes um deltax und deltay //
        keine Perspektivenangleichung}
      DeltaX   : integer;
      DeltaY   : integer;
      {finales Scaling der Welt}
      FinalScalingX  : word;
      FinalScalingY  : word;
      FinalScalingZ  : word;
      {wenn der abstand kleiner ist als 20, dann nicht mehr zeichnen}
      EleminationDistance : byte;

      {Koordinaten des Spielers}
      PlayerTra : T3D;
      PlayerRot : T3Dinteger;
      {larry}
      Player2Tra : T3D;
      Player2Rot : T3Dinteger;


      {hoch/runterschau-winkel}
      Winkel0 : integer;
    end;

procedure DisplayVideo3DInfo;
procedure DisplayWorldInfo(world : PWorld3d);

procedure LoadWorld3D(VAR World : PWorld3D; name :String);
procedure CloseWorld3D(VAR World : PWorld3D);

procedure RotateWorld3D(VAR World : PWorld3D );

{ draw virtual world in 320x200x256 }
procedure DrawWorld3D(VAR World : PWorld3D);
{ draw virtual world in 640x480x256 }
procedure DrawWorld3D101h(VAR World : PWorld3D);

procedure GetPlayerOrders( VAR World : PWorld3D;
                           StepRot,StepTra,StepDelta,
                           StepPlyTra,StepPlyRot : byte;
                           Scaling : real
                            );


procedure DirectTraRelObject( VAR World : PWorld3d;
                              ObjNo : word;
                              DirectTra : T3D );
  { not implemented yet }
procedure DirectRotObject( VAR World : PWorld3d;
                           ObjNo : word );


implementation

uses _KBDHand;


procedure AddTextureToTexturelist( TextureList : PTextureList;
                                   VAR Counter  : Word;
                                   FileName  : String );
var
  i : word;
begin
  {check if texture already loaded to memory}
  if Counter > 0 then
    begin
      i := 0;
      while ( i < MaxTextures-1 ) and
            ( TextureList^[i].Data.mem <> NIL ) do
        begin
          if FileName = TextureList^[i].FileName then
            begin
              Counter := i+1;
              exit;
            end;
          inc( i );
        end;
    end;
  Counter := i;
  {no, then load it!}
{  if texturelist^[counter].Data.mem <> nil then write( '###' );
  writeln(FileName);
  writeln(counter);
  readkey;}
  LoadImprocesCLB( FileName, TextureList^[Counter].Data );
  TextureList^[Counter].FileName := FileName;
  Inc( Counter );
end;


procedure AddObject3D( VAR World    : PWorld3D;
                           Name     : String;
                           Delta    : array of longint;
                           DeltaVecNumber : word;
                           Scaling  : real     );
var
  TextFile : text;
  tx : string; {multi-use string file}
  hr : real;
  i : longint;

  { *** fr Gouraud *** }
  Count : byte;

begin
  tx := '';
  for i := 1 to length(name) do if name[i] <> ' ' then tx := tx + name[i];
  name := tx;
  {}
  assign( TextFile ,name);
  reset( TextFile );
  {}
  with World^ do begin
    { damit man leichter damit umgehen kann z.g. for .. i := 0 to ..-1 DO ..}
    dec(VectorCounter);
    dec(ElementCounter);
    {ein Objekt einladen}
    while not eof( TextFile ) do begin
      readln( TextFile, tx );
      if tx = '[END]' then break
      else
        if tx = '[VECTOR]' then
          begin
            Inc(VectorCounter);
            for i:=0 to 2 do
              begin
                readln( TextFile , hr );
                if IOResult<>0 then writeln('Error reading vector data...');
                VectorList^[VectorCounter ,i]:=
                  round( hr * Scaling ) * PointAdj + delta[i];
              end;
          end
      else
        if tx = '[POINT]' then
          begin
            Inc(ElementCounter);
            {typ Point}
            {New(ElementList^[ElementCounter]);}
            ElementList^[ElementCounter].Typ    := Point;
            { farbe und vecternr lesen}
            readln( TextFile, hr);
            ElementList^[ElementCounter].Color[0] := round( hr );
            readln( TextFile, hr );
            if IOResult<>0 then writeln('Error reading vector data...');
            ElementList^[ElementCounter].Number[0] := round( hr ) + DeltaVecNumber;
          end
      else
        if tx = '[LINE]' then
          begin
            Inc(ElementCounter);
            {typ}
            {New(ElementList^[ElementCounter]);}
            ElementList^[ElementCounter].Typ   := NormLine;
            {farbe und 2 vectorennr. lesen}
            readln( TextFile, hr);
            ElementList^[ElementCounter].Color[0] := round( hr );
            for i:=0 to 1 do
              begin
                readln( TextFile, hr );
                if IOResult<>0 then writeln('Error reading vector data...');
                ElementList^[ElementCounter].Number[i]:=round( hr ) + DeltaVecNumber;
              end;
         end
      else
        if tx = '[TRIANGLE]' then
          begin
            Inc(ElementCounter);
            {type}
            {New(ElementList^[ElementCounter]);}
            ElementList^[ElementCounter].Typ   := Triangle;
            {}
            readln( TextFile, hr);
            ElementList^[ElementCounter].Color[0] := round( hr );
            for i:=0 to 2 do
              begin
                readln( TextFile, hr );
                if IOResult<>0 then writeln('Error reading vector data...');
                ElementList^[ElementCounter].Number[i]:=round( hr ) + DeltaVecNumber;
              end;
         end
      else
         if tx ='[RECTANGLE]' then
           begin
             Inc(ElementCounter);
             {typ}
             {New(ElementList^[ElementCounter]);}
             ElementList^[ElementCounter].Typ   := Rectangle;
             {}
             readln( TextFile, hr);
             ElementList^[ElementCounter].Color[0] := round( hr );
             for i:=0 to 3 do
               begin
                 readln( TextFile, hr );
                 if IOResult<>0 then writeln('Error reading vector data...');
                 ElementList^[ElementCounter].Number[i]:=round( hr ) + DeltaVecNumber;
              end;
           end
      else
         if tx ='[GOURAUD]' then
           begin
             Inc(ElementCounter);
             {typ}
             {New(ElementList^[ElementCounter]);}
             ElementList^[ElementCounter].Typ   := Gouraud;
             { wieviele Ecken ??? Mind. 3! Maximal 4! }
             readln( TextFile, hr);
             Count := round( hr );
             ElementList^[ElementCounter].Count := Count;
             {nun die farben}
             for i:=0 to Count-1 do
               begin
                 readln( TextFile, hr);
                 ElementList^[ElementCounter].Color[i] := round( hr );
               end;
             {und die vektoren}
             for i:=0 to Count-1 do
               begin
                 readln( TextFile, hr );
                 if IOResult<>0 then writeln('Error reading vector data...');
                 { ** Die elemente bitte linksherum ablegen!!! }
                 ElementList^[ElementCounter].Number[i]:= round( hr ) + DeltaVecNumber;
              end;
           end
      else
         if tx ='[TEXTURE]' then
           begin
             Inc(ElementCounter);
             {typ}
             {New(ElementList^[ElementCounter]);}
             ElementList^[ElementCounter].Typ   := Texture;
             { filename des textures einlesen // MU NOCH GEMACHT WERDEN }
             readln( TextFile, tx );
             AddTextureToTextureList( TextureList, TextureCounter, tx );
             { TextureCounter enthaelt den zahlenwert der Textur }
             ElementList^[ElementCounter].Color[0] := TextureCounter - 1;
             for i:=0 to 3 do
               begin
                 readln( TextFile, hr );
                 if IOResult<>0 then writeln('Error reading vector data...');
                 ElementList^[ElementCounter].Number[i]:=round( hr ) + DeltaVecNumber;
              end;
           end
      {$IFDEF EnablePseudoTextures}
      else
         if tx ='[PSEUDOTEXTURE]' then
           begin
             Inc(ElementCounter);
             {typ}
             {New(ElementList^[ElementCounter]);}
             ElementList^[ElementCounter].Typ   := PseudoTexture;
             { filename des textures einlesen // MU NOCH GEMACHT WERDEN }
             readln( TextFile, tx );
             AddTextureToTextureList( TextureList, TextureCounter, tx );
             { TextureCounter enthaelt den zahlenwert der Textur }
             ElementList^[ElementCounter].Color[0] := TextureCounter - 1;
             for i := 0 to 1 do
               begin
                 readln( TextFile, hr );
                 if IOResult<>0 then writeln('Error reading vector data...');
                 ElementList^[ElementCounter].Number[i]:=
                   round( hr ) + DeltaVecNumber;
              end;
           end
      else
         if tx ='[PSEUDOTEXTURETRANS]' then
           begin
             Inc(ElementCounter);
             {typ}
             {New(ElementList^[ElementCounter]);}
             ElementList^[ElementCounter].Typ   := PseudoTextureTrans;
             { filename des textures einlesen // MU NOCH GEMACHT WERDEN }
             readln( TextFile, tx );
             AddTextureToTextureList( TextureList, TextureCounter, tx );
             { TextureCounter enthaelt den zahlenwert der Textur }
             ElementList^[ElementCounter].Color[0] := TextureCounter - 1;
             { zu versteckende Farbe}
             readln( TextFile, hr );
             ElementList^[ElementCounter].Color[1] := round( hr );
             {}
             for i := 0 to 1 do
               begin
                 readln( TextFile, hr );
                 if IOResult<>0 then writeln('Error reading vector data...');
                 ElementList^[ElementCounter].Number[i]:=
                   round( hr ) + DeltaVecNumber;
              end;
           end
      {$ENDIF}
      {else
            writeln( tx ); { ignore unkown tag }
    end; {while}
    {}
    close( TextFile );
    { damit man leichter damit umgehen kann z.g. for .. i := 0 to ..-1 DO ..}
    Inc(VectorCounter);
    Inc(ElementCounter);
  end;
end;

procedure LoadWorld3D(VAR World : PWorld3D; name :String);

var
  i    : Integer;
  fl   : Text;
  tx   : String;
  hr   : Real;
  hc   : Word;
  tx2  : String;
  delta : array[x..z] of longint;
  subname : string;

begin
  {keinen Speicher blockieren}
  if World <> nil then
    begin
      setvideomode($3);
      writeln(#7, 'ERROR occured: trying to load a world over an existing one');
    end;
  {}
  New(World);
  {}
  with World^ do begin
    {Zentralperspektive}
    DeltaX := 160; { der Vektor (0,0) wird auf (160,100) verschoben, }
    DeltaY := 100; { d.h. in genau in die Bildschirmmitte            }
    {Perspektive nach links oben}
    {deltax := 0; deltay := 0; }
    {Perspektive nach rechts oben}
    {deltax := 319; deltay := 0; }
    {Perspektive nach links unten}
    {deltax := 0; deltay := 199; }
    {Perspektive nach rechts unten}
    {deltax := 319; deltay := 199; }
    FinalScalingX := PointAdj;
    FinalScalingY := PointAdj;
    FinalScalingZ := Round( PointAdj * 1.25 );
    {}
    Winkel0 := 0; {geradeausschauen // nicht nach oben oder unten}
    {}
    EleminationDistance := 40; {30 ist ganz nett}
    {am anfang haben wir nix}
    VectorCounter := 0;
    ElementCounter := 0;
    ObjectCounter := 0;
    TextureCounter := 0;
    {Speicher fr neue Listen reservieren}
    New(VectorList);
    {fr die transformierten und die 2d natrlich auch}
    New(TransList);
    New(Point2DList);

    New(ElementList);
    New(ElementZEntryList);

    New(ObjectList);

    New(TextureList);
    for i := 0 to MaxTextures - 1 do
      begin { brute force method to kill data}
        TextureList^[i].Data.Mem := Nil;
        TextureList^[i].Data.b   := 0;
        TextureList^[i].Data.t   := 0;
      end;

    Assign(fl,name);
    Reset(fl);
    {}
    while not eof(fl) do
      begin
        readln( fl, tx );
        if tx = '[END]' then break
        else
          if tx = '[START]' then
            begin
              readln( fl, hr); Rot[X] := Round( hr );
              readln( fl, hr); Rot[Y] := Round( hr );
              readln( fl, hr); Rot[Z] := Round( hr );
              readln( fl, hr); Tra[X] := PointAdj * Round( hr );
              readln( fl, hr); Tra[Y] := PointAdj * Round( hr );
              readln( fl, hr); Tra[Z] := PointAdj * Round( hr );
              readln( fl, hr); PlayerRot[X] := Round( hr );
              readln( fl, hr); PlayerRot[Y] := Round( hr );
              readln( fl, hr); PlayerRot[Z] := Round( hr );
              readln( fl, hr); PlayerTra[X] := PointAdj * Round( hr );
              readln( fl, hr); PlayerTra[Y] := PointAdj * Round( hr );
              readln( fl, hr); PlayerTra[Z] := PointAdj * Round( hr );
              {Larry}
              player2Rot[x]:=PlayerRot[x]+20;
              player2Rot[Y]:=PlayerRot[Y];
              player2Rot[Z]:=PlayerRot[z];
              player2Tra[x]:=PlayerTra[x]+20;
              player2Tra[Y]:=PlayerTra[Y];
              player2Tra[Z]:=PlayerTra[z];
            end
        else
          if tx = '[OBJECT]' then
            begin
              {bestimmung der Abhngigkeit}
              readln( fl ,tx2);
              tx := '';
              for i := 1 to length(tx2) do
                if tx2[i] <> ' ' then tx := tx + tx2[i];
              if tx = 'NO' then
                ObjectList^[ObjectCounter].Dependence  := NoDependence
              else
              if tx = 'WORLDTRA' then
                ObjectList^[ObjectCounter].Dependence  := WorldTra
              else
              if tx = 'WORLDROT' then
                ObjectList^[ObjectCounter].Dependence  := WorldRot
              else
              if tx = 'WORLDTRAROT' then
                ObjectList^[ObjectCounter].Dependence  := WorldTraRot
              else
              if tx = 'HEADTRA' then
                ObjectList^[ObjectCounter].Dependence  := HeadTra
              else
              if tx = 'HEADROT' then
                ObjectList^[ObjectCounter].Dependence  := HeadRot
              else
              if tx = 'HEADTRAROT' then
                ObjectList^[ObjectCounter].Dependence  := HeadTraRot
              else
                begin
                  setvideomode(3);
                  writeln('Unknown dependence-type occured:',tx); halt(0);
                end;
              {name}
              readln( fl ,tx);
              subname := tx;
              {Writeln('Object Name: ',tx);
              writeln('AnfangsVector : ', VectorCounter);
              writeln('AnfangsElement: ', ElementCounter);}
              ObjectList^[ObjectCounter].StartVector  := VectorCounter;
              ObjectList^[ObjectCounter].StartElement := ElementCounter;
              ObjectList^[ObjectCounter].FileName := tx;
              {einladen von TraX-Z,RotX-Z sowie Scaling}
              readln(fl,hr); ObjectList^[ObjectCounter].Tra[X] := PointAdj * round(hr);
              readln(fl,hr); ObjectList^[ObjectCounter].Tra[Y] := PointAdj * round(hr);
              readln(fl,hr); ObjectList^[ObjectCounter].Tra[Z] := PointAdj * round(hr);
              readln(fl,hr); ObjectList^[ObjectCounter].Rot[X] := round(hr);
              readln(fl,hr); ObjectList^[ObjectCounter].Rot[Y] := round(hr);
              readln(fl,hr); ObjectList^[ObjectCounter].Rot[Z] := round(hr);
              {soll ich zuerst rotieren und dann translatieren oder
                        erst translatieren und dann rotieren ???    }
              {bestimmung der Abhngigkeit}
              readln( fl ,tx2);
              tx := '';
              for i := 1 to length(tx2) do
                if tx2[i] <> ' ' then tx := tx + tx2[i];
              tx2 := tx;
              if tx2 = 'WORLD' then
                begin
                 delta[x] := ObjectList^[ObjectCounter].Tra[X];
                 delta[y] := ObjectList^[ObjectCounter].Tra[Y];
                 delta[z] := ObjectList^[ObjectCounter].Tra[Z];
                end else
{              if tx2 = 'PLAYER' then
                begin
                 delta[x] := ObjectList^[ObjectCounter].TraX - HeadTraX;
                 delta[y] := ObjectList^[ObjectCounter].TraY - HeadTraY;
                 delta[z] := ObjectList^[ObjectCounter].TraZ - HeadTraZ;
                end else}
              if tx2 = 'OBJECT' then
                begin
                  delta[x] := 0; delta[y] := 0; delta[z] := 0;
                end else
                  begin
                    setvideomode(3);
                    writeln('Each object has to be INCLUDED or EXCLUDED.');
                    writeln('You tried to:', tx2);
                    writeln;
                    writeln('WORLD  -> Rotating object about 0-Vector of the world');
                    writeln('OBJECT -> Rotation object about its own 0-Vector');
                    writeln('PLAYER -> Rotation object about Player-Vector');
                    halt(0);
                  end;
              {}
              readln(fl,hr); {<-- das scaling}
              AddObject3D(World, subname, delta, VectorCounter, hr );
              {writeln('EndeVector    : ', VectorCounter-1);
              writeln('EndeElement   : ', ElementCounter-1);}
              ObjectList^[ObjectCounter].EndVector  := VectorCounter-1;
              ObjectList^[ObjectCounter].EndElement := ElementCounter-1;
              {wenn ich um den Welt-0-Vektor drehe, dann lschen}
              if tx2 = 'WORLD' then
                 LInt2Vec3D( 0,0,0, ObjectList^[ObjectCounter].Tra );
                 {ObjectList^[ObjectCounter].Tra[X] := 0;
                 ObjectList^[ObjectCounter].Tra[Y] := 0;
                 ObjectList^[ObjectCounter].Tra[Z] := 0;}
              Inc(ObjectCounter);
            end
        {else writeln( tx ); {ignore}
      end;
    {}
    Close( fl );
  end;

end;



procedure CloseWorld3D(VAR World : PWorld3D);
var
  i : word;
begin
  with World^ do
    begin
      {und hier die Sprites frei geben}
      for i := 0 to MaxTextures - 1 do
        CloseSprite( TextureList^[i].Data );

      Dispose(TextureList);

      Dispose(VectorList);

      Dispose(ElementList);
      Dispose(ElementZEntryList);

      Dispose(ObjectList);

      VectorCounter := -1;
      ElementCounter := -1;

      Dispose(TransList);
      Dispose(Point2DList);

    end;
  Dispose(World);
end;

procedure ProjectObject(VAR World : PWorld3D; VAR Matrix : TMatrix4x4;
                            fromVector, toVector : Longint );
var
  i : LongInt;
  OutputVector : T3D;
  TempVector   : T3D;
  Divisor : LongInt;

begin
  with World^ do
    { *** neuen Vektor bzgl. Rotation und Translation berechnen *** }
    for i:= fromVector to toVector do begin
      { *** Ok, die gesammte Welt um Playerposition verschieben *** }
      {TempVector[x] := VectorList^[i][x] + PlayerTra[X];
      TempVector[y] := VectorList^[i][y] + PlayerTra[Y];
      TempVector[z] := VectorList^[i][z] + PlayerTra[Z];}
      VecAdd3D( VectorList^[i], PlayerTra, TempVector );
      { *** tranformierten Vektor berechnen ***}
      TransformVecMatrix( TempVector, Matrix , OutputVector);

      { *** wird eigentlich nur bentigt, wenn auf dem z-Wert geachtet
            werden mu, wie z.b. beim Painter-Algorihtmus              *** }
      TransList^[i]:= OutputVector;
      { *** Berechnet aus dem transformierten Vektor die 2d-Koordinaten,
            durch Projektion auf die x-y-Ebene                         *** }
      Divisor := Outputvector[z];
      If Divisor <> 0 then
        begin
          Point2DList^[i,x] :=
            DeltaX + (longint(OutputVector[x]) * PointAdj) div Divisor;
          Point2DList^[i,y] :=
            DeltaY - (LongInt(OutputVector[y]) * PointAdj) div Divisor;
        end
      else
        begin
          Point2DList^[i,x] := 2147483647;
          Point2DList^[i,y] := 2147483647;
        end;
    end;
end;

{ *** Ermittlung des Z-Wertes durch:
      Z-Wert jeder Ecke addieren / anzahl der ecken (PAINTER-Algo.) *** }
procedure UpdateElementZEntryList(VAR World : PWorld3D );
var
  i, number : Integer;
  summe     : longint;
  Help      : integer;
begin
  with World^ do
    for i := 0 to ElementCounter-1 do
      begin
        case ElementList^[i].Typ of
          Point :
            begin
              {Durchschnitts-z-wert des translatierten Vektoers nehmen}
              summe := TransList^[ElementList^[i].Number[0]][z];
              ElementZEntryList^[i].z:= summe;
              ElementZEntryList^[i].Reference := i; {**mu das wirklich rein???**}
            end;
          NormLine :
            begin
              {Durchschnitts-z-wert des translatierten Vektoers nehmen}
              summe := TransList^[ElementList^[i].Number[0]][z]+
                       TransList^[ElementList^[i].Number[1]][z];
              ElementZEntryList^[i].z:= summe div 2;
              ElementZEntryList^[i].Reference := i; {**mu das wirklich rein???**}
            end;
          Triangle :
            begin
              {Durchschnitts-z-wert des translatierten Vektoers nehmen}
              summe := TransList^[ElementList^[i].Number[0]][z]+ {links oben}
                       TransList^[ElementList^[i].Number[1]][z]+ {rechts oben}
                       TransList^[ElementList^[i].Number[2]][z]; {rechts unten}
              ElementZEntryList^[i].z:= summe div 3;
              ElementZEntryList^[i].Reference := i; {**mu das wirklich rein???**}
            end;
          Rectangle :
            begin
              {Durchschnitts-z-wert des translatierten Vektoers nehmen}
              summe := TransList^[ElementList^[i].Number[0]][z]+ {links oben}
                       TransList^[ElementList^[i].Number[1]][z]+ {rechts oben}
                       TransList^[ElementList^[i].Number[2]][z]+ {rechts unten}
                       TransList^[ElementList^[i].Number[3]][z]; {links unten}
              ElementZEntryList^[i].z:= summe div 4;
              ElementZEntryList^[i].Reference := i; {**mu das wirklich rein???**}
            end;
          Gouraud :
            begin
              {Durchschnitts-z-wert des translatierten Vektoers nehmen}
              summe := 0;
              for Help := 0 to ElementList^[i].Count-1 do
                summe := summe + TransList^[ElementList^[i].Number[Help]][z];
              ElementZEntryList^[i].z:= summe div ElementList^[i].Count-1;
              ElementZEntryList^[i].Reference := i; {**mu das wirklich rein???**}
            end;
          Texture :
            begin
              {Durchschnitts-z-wert des translatierten Vektoers nehmen}
              summe := TransList^[ElementList^[i].Number[0]][z]+ {links oben}
                       TransList^[ElementList^[i].Number[1]][z]+ {rechts oben}
                       TransList^[ElementList^[i].Number[2]][z]+ {rechts unten}
                       TransList^[ElementList^[i].Number[3]][z]; {links unten}
              ElementZEntryList^[i].z:= summe div 4;
              ElementZEntryList^[i].Reference := i; {**mu das wirklich rein???**}
            end;
          {$IFDEF EnablePseudoTextures}
          PseudoTexture,PseudoTextureTrans :
            begin
              summe := TransList^[ElementList^[i].Number[0]][z]+
                       TransList^[ElementList^[i].Number[1]][z];
              ElementZEntryList^[i].z:= summe div 2;
              ElementZEntryList^[i].Reference := i; {**mu das wirklich rein???**}
            end;
          {$ENDIF}
          else begin setvideomode($3); writeln('Unknown Element type!'); halt(0); end;
        end;
  end;
end;

procedure SortElementZEntryList(VAR World : PWorld3D; l, r : Integer);
var
  i,j  : Integer;
  x : LongInt;
  ZEntry : ElementZEntry; {ein einzelner eintrag}

begin
  i := l;
  j := r;

  with World^ do
    begin
      x := ElementZEntryList^[(l+r) shr 1].z; {z von der mitte nehmen}

      repeat

        while ElementZEntryList^[i].z < x do Inc(i);

        while ElementZEntryList^[j].z > x do Dec(j);

        if i <= j then
          begin
            ZEntry                := ElementZEntryList^[i];
            ElementZEntryList^[i] := ElementZEntryList^[j];
            ElementZEntryList^[j] := ZEntry;
            Inc(i);
            Dec(j);
          end;

      until i > j;

      if l < j then SortElementZEntryList(World, l, j);
      if i < r then SortElementZEntryList(World, i, r);
    end;
end;


procedure RotateWorld3D(VAR World : PWorld3D );
var
  Matrix   : TMatrix4x4;
  Rotation : TMatrix4x4;
  i :LongInt;
begin
  with World^ do
    for i := 0 to ObjectCounter-1 do
      {if not ObjectList^[i].AlreadyMoved then}
        begin
          case ObjectList^[i].Dependence of
{          NoDependence :
            CreateMatrix( ObjectList^[i].Tra[X],
                          ObjectList^[i].Tra[Y],
                          ObjectList^[i].Tra[Z],
                          FinalScalingX, FinalScalingY, FinalScalingZ,
                          ObjectList^[i].Rot[X],
                          ObjectList^[i].Rot[Y],
                          ObjectList^[i].Rot[Z],
                          Matrix);
{          WorldTra :
            CreateMatrix( Tra[X] + ObjectList^[i].Tra[X],
                          Tra[Y] + ObjectList^[i].Tra[Y],
                          Tra[Z] + ObjectList^[i].Tra[Z],
                          FinalScalingX, FinalScalingY, FinalScalingZ,
                          HeadRotX + ObjectList^[i].Rot[X],
                          HeadRotY + ObjectList^[i].Rot[Y],
                          HeadRotZ + ObjectList^[i].Rot[Z],
                          Matrix);
          WorldRot :
            CreateMatrix( ObjectList^[i].Tra[X],
                          ObjectList^[i].Tra[Y],
                          ObjectList^[i].Tra[Z],
                          FinalScalingX, FinalScalingY, FinalScalingZ,
                          Rot[X] + HeadRotX + ObjectList^[i].Rot[X],
                          Rot[Y] + HeadRotY + ObjectList^[i].Rot[Y],
                          Rot[Z] + HeadRotZ + ObjectList^[i].Rot[Z],
                          Matrix );}
            WorldTraRot :
              CreateMatrix( Tra[X] + ObjectList^[i].Tra[X],
                            Tra[Y] + ObjectList^[i].Tra[Y],
                            Tra[Z] + ObjectList^[i].Tra[Z],
                            FinalScalingX, FinalScalingY, FinalScalingZ,
                            Rot[X] + PlayerRot[X] + ObjectList^[i].Rot[X],
                            Rot[Y] + PlayerRot[Y] + ObjectList^[i].Rot[Y],
                            Rot[Z] + PlayerRot[Z] + ObjectList^[i].Rot[Z],
                            Matrix );
         (* HeadTra :
            CreateMatrix( Tra[X] - PlayerTra[X] + ObjectList^[i].Tra[X],
                          Tra[Y] - PlayerTra[Y] + ObjectList^[i].Tra[Y],
                          Tra[Z] - PlayerTra[Z] + ObjectList^[i].Tra[Z],
                          FinalScalingX, FinalScalingY, FinalScalingZ,
                          Rot[X] + { PlayerRot[X] + {} ObjectList^[i].Rot[X],
                          Rot[Y] + { PlayerRot[Y] + {} ObjectList^[i].Rot[Y],
                          Rot[Z] + { PlayerRot[Z] + {} ObjectList^[i].Rot[Z],
                          Matrix );*)
      {    HeadRot :
            CreateMatrix( Tra[X] + ObjectList^[i].Tra[X],
                          Tra[Y] + ObjectList^[i].Tra[Y],
                          Tra[Z] + ObjectList^[i].Tra[Z],
                          FinalScalingX, FinalScalingY, FinalScalingZ,
                          Rot[X] + HeadRotX + ObjectList^[i].Rot[X],
                          Rot[Y] + HeadRotY + ObjectList^[i].Rot[Y],
                          Rot[Z] + HeadRotZ + ObjectList^[i].Rot[Z],
                          Matrix );}
            HeadTraRot :
              CreateMatrix( Tra[X] - PlayerTra[X] + ObjectList^[i].Tra[X],
                            Tra[Y] - PlayerTra[Y] + ObjectList^[i].Tra[Y],
                            Tra[Z] - PlayerTra[Z] + ObjectList^[i].Tra[Z],
                            FinalScalingX, FinalScalingY, FinalScalingZ,
                            ObjectList^[i].Rot[X],
                            ObjectList^[i].Rot[Y],
                            ObjectList^[i].Rot[Z],
                            Matrix );
            else
              begin
                setvideomode(3);
                writeln('Unknown dependence-type on run-time'); halt(0);
              end;
          end;
          {berechnet die Rotationsmatrix // nur fr Normalenvektoren interresant}
          (*RotateMatrix(Obj^.RotX, Obj^.RotY, Obj^.RotZ, Rotation);*)
          {projeziert nun dieses Objekt bzgl der Matrix 'Matrix'}
    {       writeln(ObjectList^[i].StartVector);
          writeln(ObjectList^[i].EndVector);}
          ProjectObject( World , Matrix,
                         ObjectList^[i].StartVector,
                         ObjectList^[i].EndVector );
        end;
    {berechne zu jedem Polygon den dazugehrigen z-wert}
  UpdateElementZEntryList( World );
 { setvideomode($3);
  writeln(world^.elementZEntryList^[0].Reference:5,world^.elementZEntryList^[0].z div PointAdj:15);
  writeln(world^.elementZEntryList^[1].Reference:5,world^.elementZEntryList^[1].z div PointAdj:15);
  writeln(world^.elementZEntryList^[2].Reference:5,world^.elementZEntryList^[2].z div PointAdj:15);
  writeln(world^.elementZEntryList^[3].Reference:5,world^.elementZEntryList^[3].z div PointAdj:15);}

  {und sotiere diese}
  SortElementZEntryList( World, {von}0, {bis}World^.ElementCounter-1);
{  writeln;
  writeln(world^.elementZEntryList^[0].Reference:5,world^.elementZEntryList^[0].z div PointAdj:15);
  writeln(world^.elementZEntryList^[1].Reference:5,world^.elementZEntryList^[1].z div PointAdj:15);
  writeln(world^.elementZEntryList^[2].Reference:5,world^.elementZEntryList^[2].z div PointAdj:15);
  writeln(world^.elementZEntryList^[3].Reference:5,world^.elementZEntryList^[3].z div PointAdj:15);
  delay(250);}
end;

procedure Exchange2D( VAR xy1 : T2Dinteger; VAR col1 : byte;
                      VAR xy2 : T2Dinteger; VAR col2 : byte );
var
  helpxy  : T2Dinteger;
  helpcol : byte;
begin
  helpxy := xy1;    helpcol := col1;
  xy1    := xy2;    col1    := col2;
  xy2    := helpxy; col2    := helpcol;
end;

procedure Sort3Edges( VAR xybuf  : array of T2Dinteger;
                      VAR colbuf : array of byte );
var
  Anzahl,
  i       : byte;
begin
  { ok, nun zuerst zweimal die liste durchgehen und sortieren }
  for Anzahl := 0 to 2 do
    for i := 0 to 1 do
      if xybuf[i][y] > xybuf[i+1][y] then
        Exchange2D( xybuf[i], colbuf[i], xybuf[i+1], colbuf[i+1] );
  { ok, dann noch einmal tauschen, damit punkte links herum gehen}
  if xybuf[2][x] > xybuf[1][x] then
    Exchange2D( xybuf[1], colbuf[1], xybuf[2], colbuf[2] );
  {irgendwo noch ein kleiner bug drin}
end;

procedure Sort4Edges( VAR xybuf  : array of T2Dinteger;
                      VAR colbuf : array of byte );

  procedure Swap2dP(var p1,p2:T2Dinteger);
  var tp:T2dInteger;
  begin
    tp:=p1;
    p1:=p2;
    p2:=tp;
  end;

  procedure SwapColBuf(var p1,p2:byte);
  var tp:byte;
  begin
    tp:=p1;
    p1:=p2;
    p2:=tp;
  end;

var sortR:array[0..3] of T2Dinteger;
    sortC:array[0..3] of byte;
begin
  {Von links nach rechts sortieren}

  if xybuf[0][x]>xybuf[1][x] then begin swap2DP(xybuf[0],xybuf[1]);
                                        swapColBuf(colbuf[0],colbuf[1]);
                                  end;
  if xybuf[2][x]>xybuf[3][x] then begin swap2DP(xybuf[2],xybuf[3]);
                                        swapColBuf(colbuf[2],colbuf[3]);
                                  end;
  if xybuf[0][x]>xybuf[2][x] then begin swap2DP(xybuf[0],xybuf[2]);
                                        swapColBuf(colbuf[0],colbuf[2]);
                                  end;
  if xybuf[1][x]>xybuf[3][x] then begin swap2DP(xybuf[1],xybuf[3]);
                                        swapColBuf(colbuf[1],colbuf[3]);
                                  end;
  if xybuf[1][x]>xybuf[2][x] then begin swap2DP(xybuf[1],xybuf[2]);
                                        swapColBuf(colbuf[1],colbuf[2]);
                                  end;

  sortR[0]:=xybuf[0];
  sortR[1]:=xybuf[1];
  sortR[2]:=xybuf[2];
  sortR[3]:=xybuf[3];
  sortC[0]:=Colbuf[0];
  sortC[1]:=Colbuf[1];
  sortC[2]:=Colbuf[2];
  sortC[3]:=Colbuf[3];

  if (xybuf[1][y]>xybuf[0][y]) and (xybuf[2][y]>xybuf[0][y])
  and (xybuf[1][y]>xybuf[3][y]) and (xybuf[2][y]<xybuf[3][y]) then begin
    sortR[1]:=xybuf[1];  sortR[2]:=xybuf[3];  sortR[3]:=xybuf[2];
    sortc[1]:=colbuf[1]; sortc[2]:=colbuf[3]; sortc[3]:=colbuf[2];
  end else
  if (xybuf[1][y]>=xybuf[0][y]) and (xybuf[2][y]>=xybuf[0][y])
  and (xybuf[2][y]<=xybuf[3][y]) then begin
    sortR[1]:=xybuf[2];  sortR[2]:=xybuf[3];  sortR[3]:=xybuf[1];
    sortc[1]:=colbuf[2]; sortc[2]:=colbuf[3]; sortc[3]:=colbuf[1];
  end else
  if (xybuf[1][y]<=xybuf[0][y]) and (xybuf[2][y]<=xybuf[0][y]) and (xybuf[2][y]>=xybuf[3][y]) then begin
    sortR[1]:=xybuf[1];  sortR[2]:=xybuf[3];  sortR[3]:=xybuf[2];
    sortC[1]:=colbuf[1]; sortc[2]:=colbuf[3]; sortc[3]:=colbuf[2];
  end else
  if (xybuf[1][y]<=xybuf[0][y]) and (xybuf[2][y]<=xybuf[0][y]) then begin
    sortR[1]:=xybuf[1];  sortR[2]:=xybuf[2];  sortR[3]:=xybuf[3];
    sortC[1]:=colbuf[1]; sortc[2]:=colbuf[2]; sortc[3]:=colbuf[3];
  end else
  if (xybuf[1][y]>=xybuf[0][y]) and (xybuf[2][y]>=xybuf[0][y]) then begin
    sortR[1]:=xybuf[3];  sortR[2]:=xybuf[2]; sortR[3]:=xybuf[1];
    sortc[1]:=colbuf[3]; sortc[2]:=colbuf[2]; sortc[3]:=colbuf[1];
  end else
  if (xybuf[1][y]<=xybuf[0][y]) and (xybuf[2][y]>=xybuf[0][y]) then begin
    sortR[1]:=xybuf[1];  sortR[2]:=xybuf[3];  sortR[3]:=xybuf[2];
    sortc[1]:=colbuf[1]; sortc[2]:=colbuf[3]; sortc[3]:=colbuf[2];
  end else
  if (xybuf[1][y]>=xybuf[0][y]) and (xybuf[2][y]<=xybuf[0][y]) then begin
    sortR[1]:=xybuf[2];  sortR[2]:=xybuf[3];  sortR[3]:=xybuf[1];
    sortc[1]:=colbuf[2]; sortc[2]:=colbuf[3]; sortc[3]:=colbuf[1];
  end;
  if (xybuf[1][y]>=xybuf[0][y]) and (xybuf[2][y]>=xybuf[0][y])
  and (xybuf[1][y]<=xybuf[3][y]) and (xybuf[2][y]<=xybuf[3][y]) then begin
    sortR[1]:=xybuf[2];  sortR[2]:=xybuf[3];  sortR[3]:=xybuf[1];
    sortc[1]:=colbuf[2]; sortc[2]:=colbuf[3]; sortc[3]:=colbuf[1];
  end;
  xybuf[0]:=sortR[0];
  xybuf[1]:=sortR[1];
  xybuf[2]:=sortR[2];
  xybuf[3]:=sortR[3];
  colbuf[0]:=sortC[0];
  colbuf[1]:=sortC[1];
  colbuf[2]:=sortC[2];
  colbuf[3]:=sortC[3];
end;


{$I _TEXTMAP.PAS}


procedure DrawWorld3D(VAR World : PWorld3D);
var
  { *** for the loop!!! DON'T USE THEM*** }
  i,j : longint;
  { *** ONLY for the Gouraud *** }
  GouBuffer : array[0..63] of T2Dinteger;
  GouColBuf : array[0..63] of Byte;
  TexBuffer : array[0..3] of T2DRecordInteger;
  Help      : byte;
  Count     : byte;

  HelpX1,
  HelpY1,
  HelpX2,
  HelpY2    : integer;
  Puffer    : integer;


begin

  {mit sortierung}
  with World^ do
   for i := ElementCounter-1 downto 0 do
      begin
        j := ElementZEntryList^[i].Reference;
        { eventuell raushngen...}
        {}if ElementZEntryList^[i].z > EleminationDistance * PointAdj then {}
        case ElementList^[j].Typ of
          Point :
            PutPixelWindow(Point2DList^[ElementList^[j].number[0]][x],
                        Point2DList^[ElementList^[j].number[0]][y],
                        ElementList^[j].Color[0]);
          NormLine :
            LineWindow(Point2DList^[ElementList^[j].number[0]][x],
                    Point2DList^[ElementList^[j].number[0]][y],
                    Point2DList^[ElementList^[j].number[1]][x],
                    Point2DList^[ElementList^[j].number[1]][y],
                    ElementList^[j].color[0]);
          Triangle :
            TriangleWindow(Point2DList^[ElementList^[j].number[0]][x],
                    Point2DList^[ElementList^[j].number[0]][y],
                    Point2DList^[ElementList^[j].number[1]][x],
                    Point2DList^[ElementList^[j].number[1]][y],
                    Point2DList^[ElementList^[j].number[2]][x],
                    Point2DList^[ElementList^[j].number[2]][y],
                    ElementList^[j].color[0]);
          Rectangle :
            RectangleWindow(Point2DList^[ElementList^[j].Number[0]][x],
                    Point2DList^[ElementList^[j].Number[0]][y],
                    Point2DList^[ElementList^[j].Number[1]][x],
                    Point2DList^[ElementList^[j].Number[1]][y],
                    Point2DList^[ElementList^[j].Number[2]][x],
                    Point2DList^[ElementList^[j].Number[2]][y],
                    Point2DList^[ElementList^[j].Number[3]][x],
                    Point2DList^[ElementList^[j].Number[3]][y],
                    ElementList^[j].Color[0]);
          Gouraud :
            begin
              Count := ElementList^[j].Count;
              case Count of
                3 :
                  begin
                    Help := 0;
                    repeat
                      GouBuffer[Help][x] :=
                        integer(Point2DList^[ElementList^[j].Number[Help]][x]);
                      GouBuffer[Help][y] :=
                        integer(Point2DList^[ElementList^[j].Number[Help]][y]);
                      GouColBuf[Help] := ElementList^[j].Color[Help];
                      inc( Help );
                    until Help = Count;
                    {$IFDEF CheckGouraud3Edges}
                    {Sort3Edges( GouBuffer, GouColBuf );}
                    {$ENDIF}
                    if not (
                       ( (GouBuffer[0][x] > wx2) and
                         (GouBuffer[1][x] > wx2) and
                         (GouBuffer[2][x] > wx2) ) or
                       ( (GouBuffer[0][x] < wx1) and
                         (GouBuffer[1][x] < wx1) and
                         (GouBuffer[2][x] < wx1) ) or
                       ( (GouBuffer[0][y] > wy2) and
                         (GouBuffer[1][y] > wy2) and
                         (GouBuffer[2][y] > wy2) ) or
                       ( (GouBuffer[0][y] < wy1) and
                         (GouBuffer[1][y] < wy1) and
                         (GouBuffer[2][y] < wy1) ) ) then
                       CxyGouraudShadedPoly( @GouBuffer, @GouColBuf, Count );
                  end;
                4 :
                  begin
                    Help := 0;
                    repeat
                      GouBuffer[Help][x] :=
                        integer(Point2DList^[ElementList^[j].Number[Help]][x]);
                      GouBuffer[Help][y] :=
                        integer(Point2DList^[ElementList^[j].Number[Help]][y]);
                      GouColBuf[Help] := ElementList^[j].Color[Help];
                      inc( Help );
                    until Help = Count;
                    {$IFDEF CheckGouraud4Edges}
{                    Sort4Edges( GouBuffer, GouColBuf );}
                    {$ENDIF}
                    if not (
                       ( (GouBuffer[0][x] > wx2) and
                         (GouBuffer[1][x] > wx2) and
                         (GouBuffer[2][x] > wx2) and
                         (GouBuffer[3][x] > wx2) ) or
                       ( (GouBuffer[0][x] < wx1) and
                         (GouBuffer[1][x] < wx1) and
                         (GouBuffer[2][x] < wx1) and
                         (GouBuffer[3][x] < wx1) ) or
                       ( (GouBuffer[0][y] > wy2) and
                         (GouBuffer[1][y] > wy2) and
                         (GouBuffer[2][y] > wy2) and
                         (GouBuffer[3][y] > wy2) ) or
                       ( (GouBuffer[0][y] < wy1) and
                         (GouBuffer[1][y] < wy1) and
                         (GouBuffer[2][y] < wy1) and
                         (GouBuffer[3][y] < wy1) ) ) then
                      CxyGouraudShadedPoly( @GouBuffer, @GouColBuf, Count );
                  end;
              end;
            end;
          Texture :
            begin
              Help := 0;
              repeat
                TexBuffer[Help].x :=
                  integer(
                      Point2DList^[ ElementList^[j].Number[Help]][x]
                    );
                TexBuffer[Help].y :=
                  integer(
                      Point2DList^[ElementList^[j].Number[Help]][y]
                    );
                inc( Help );
              until Help = 4;
              PutTextureWindow( TexBuffer,
                                TextureList^[ ElementList^[j].Color[0] ].Data );

            end;
          {$IFDEF EnablePseudoTextures}
          PseudoTexture :
            begin
              HelpX1 := integer(Point2DList^[ ElementList^[j].Number[0]][x]);
              HelpY1 := integer(Point2DList^[ ElementList^[j].Number[0]][y]);
              HelpX2 := integer(Point2DList^[ ElementList^[j].Number[1]][x]);
              HelpY2 := integer(Point2DList^[ ElementList^[j].Number[1]][y]);

              if HelpX1 > HelpX2 then
                begin
                  Puffer := HelpX1;
                  HelpX1 := HelpX2;
                  HelpX2 := Puffer;
                end;
              if HelpY1 > HelpY2 then
                begin
                  Puffer := HelpY1;
                  HelpY1 := HelpY2;
                  HelpY2 := Puffer;
                end;

              HelpX2 := longint( HelpX2 ) - HelpX1;
              HelpY2 := longint( HelpY2 ) - HelpY1;

              if ( ( HelpX1 >= 0 ) and ( HelpX2 <= 319 ) and
                   ( HelpY1 >= 0 ) and ( HelpY2 <= 199 ) ) then
                PutSpriteScaled(
                  HelpX1,
                  HelpY1,
                  HelpX2,
                  HelpY2,
                  TextureList^[ ElementList^[j].Color[0] ].Data );
            end;
          PseudoTextureTrans :
            begin
              HelpX1 := integer(Point2DList^[ ElementList^[j].Number[0]][x]);
              HelpY1 := integer(Point2DList^[ ElementList^[j].Number[0]][y]);
              HelpX2 := integer(Point2DList^[ ElementList^[j].Number[1]][x]);
              HelpY2 := integer(Point2DList^[ ElementList^[j].Number[1]][y]);

              if HelpX1 > HelpX2 then
                begin
                  Puffer := HelpX1;
                  HelpX1 := HelpX2;
                  HelpX2 := Puffer;
                end;
              if HelpY1 > HelpY2 then
                begin
                  Puffer := HelpY1;
                  HelpY1 := HelpY2;
                  HelpY2 := Puffer;
                end;

              HelpX2 := longint( HelpX2 ) - HelpX1;
              HelpY2 := longint( HelpY2 ) - HelpY1;

              PutSpriteScaledTrans(
                HelpX1,
                HelpY1,
                HelpX2,
                HelpY2,
                ElementList^[j].Color[1], {zu versteckende Farbe}
                TextureList^[ ElementList^[j].Color[0] ].Data );
            end;
            {$ENDIF}
        end;
      end;
end;

procedure DrawWorld3D101h(VAR World : PWorld3D);
var
  i,j : longint;
  { *** ONLY for the Gouraud *** }
  GouBuffer : array[0..63] of T2Dinteger;
  GouColBuf : array[0..63] of Byte;
  TexBuffer : array[0..63] of T2DRecordInteger;
  Help      : byte;
  Count     : byte;
  Page      : byte;

  HelpX1,
  HelpY1,
  HelpX2,
  HelpY2    : integer;
  Puffer    : integer;

begin

{mit sortierung}
  with World^ do
   for i := ElementCounter-1 downto 0 do
      begin
        j := ElementZEntryList^[i].Reference;
        { eventuell raushngen...}
        {}if ElementZEntryList^[i].z > EleminationDistance * PointAdj then {}
        case ElementList^[j].Typ of
          Point :
            PutPixelWindow101h(Point2DList^[ElementList^[j].number[0]][x],
                        Point2DList^[ElementList^[j].number[0]][y],
                        ElementList^[j].Color[0]);
          NormLine :
            LineWindow101h(Point2DList^[ElementList^[j].number[0]][x],
                    Point2DList^[ElementList^[j].number[0]][y],
                    Point2DList^[ElementList^[j].number[1]][x],
                    Point2DList^[ElementList^[j].number[1]][y],
                    ElementList^[j].color[0]);
          Triangle :
            TriangleWindow101h(Point2DList^[ElementList^[j].number[0]][x],
                    Point2DList^[ElementList^[j].number[0]][y],
                    Point2DList^[ElementList^[j].number[1]][x],
                    Point2DList^[ElementList^[j].number[1]][y],
                    Point2DList^[ElementList^[j].number[2]][x],
                    Point2DList^[ElementList^[j].number[2]][y],
                    ElementList^[j].color[0]);
          Rectangle :
            RectangleWindow101h(Point2DList^[ElementList^[j].Number[0]][x],
                    Point2DList^[ElementList^[j].Number[0]][y],
                    Point2DList^[ElementList^[j].Number[1]][x],
                    Point2DList^[ElementList^[j].Number[1]][y],
                    Point2DList^[ElementList^[j].Number[2]][x],
                    Point2DList^[ElementList^[j].Number[2]][y],
                    Point2DList^[ElementList^[j].Number[3]][x],
                    Point2DList^[ElementList^[j].Number[3]][y],
                    ElementList^[j].Color[0]);
          Gouraud :
            begin
              Count := ElementList^[j].Count;
              case Count of
                3 :
                  for page:=0 to 5 do
                    begin
                      Help := 0;
                      repeat
                        GouBuffer[Help][x] :=
                          CalcPageX(integer(Point2DList^[ElementList^[j].Number[Help]][x]), Page);
                        GouBuffer[Help][y] :=
                          CalcPageY(integer(Point2DList^[ElementList^[j].Number[Help]][y]), Page);
                        GouColBuf[Help] := ElementList^[j].Color[Help];
                        inc( Help );
                      until Help = Count;
                      {$IFDEF CheckGouraud3Edges}
                      Sort3Edges( GouBuffer, GouColBuf );
                      {$ENDIF}
                      ActVPage:=ActVPage101h[page];
                      SetWindow(Windows101h[page,1],Windows101h[page,3],Windows101h[page,2],Windows101h[page,4]);
                      if not (
                         ( (GouBuffer[0][x] > wx2) and
                           (GouBuffer[1][x] > wx2) and
                           (GouBuffer[2][x] > wx2) ) or
                         ( (GouBuffer[0][x] < wx1) and
                           (GouBuffer[1][x] < wx1) and
                           (GouBuffer[2][x] < wx1) ) or
                         ( (GouBuffer[0][y] > wy2) and
                           (GouBuffer[1][y] > wy2) and
                           (GouBuffer[2][y] > wy2) ) or
                         ( (GouBuffer[0][y] < wy1) and
                           (GouBuffer[1][y] < wy1) and
                           (GouBuffer[2][y] < wy1) ) ) then
                      CxyGouraudShadedPoly( @GouBuffer, @GouColBuf, Count );
                    end;
                4 :
                  for page:=0 to 5 do
                    begin
                    Help := 0;
                      repeat
                        GouBuffer[Help][x] :=
                          CalcPageX(integer(Point2DList^[ElementList^[j].Number[Help]][x]), Page);
                        GouBuffer[Help][y] :=
                          CalcPageY(integer(Point2DList^[ElementList^[j].Number[Help]][y]), Page);
                        GouColBuf[Help] := ElementList^[j].Color[Help];
                        inc( Help );
                      until Help = Count;
                        {$IFDEF CheckGouraud4Edges}
                        Sort4Edges( GouBuffer, GouColBuf );
                        {$ENDIF}
                        ActVPage:=ActVPage101h[page];
                        SetWindow(Windows101h[page,1],Windows101h[page,3],Windows101h[page,2],Windows101h[page,4]);
                      if not (
                         ( (GouBuffer[0][x] > wx2) and
                           (GouBuffer[1][x] > wx2) and
                           (GouBuffer[2][x] > wx2) and
                           (GouBuffer[3][x] > wx2) ) or
                         ( (GouBuffer[0][x] < wx1) and
                           (GouBuffer[1][x] < wx1) and
                           (GouBuffer[2][x] < wx1) and
                           (GouBuffer[3][x] < wx1) ) or
                         ( (GouBuffer[0][y] > wy2) and
                           (GouBuffer[1][y] > wy2) and
                           (GouBuffer[2][y] > wy2) and
                           (GouBuffer[3][y] > wy2) ) or
                         ( (GouBuffer[0][y] < wy1) and
                           (GouBuffer[1][y] < wy1) and
                           (GouBuffer[2][y] < wy1) and
                           (GouBuffer[3][y] < wy1) ) ) then

                        CxyGouraudShadedPoly( @GouBuffer, @GouColBuf, Count );
                    end;
              end;
            end;
          Texture :
            begin
              Help := 0;
              repeat
                TexBuffer[Help].x :=
                  integer(
                      Point2DList^[ ElementList^[j].Number[Help]][x]
                    );
                TexBuffer[Help].y :=
                  integer(
                      Point2DList^[ElementList^[j].Number[Help]][y]
                    );
                inc( Help );
              until Help = 4;
              PutTextureWindow101h( TexBuffer,
                                TextureList^[ ElementList^[j].Color[0] ].Data );

            end;
          {$IFDEF EnablePseudoTextures}
          PseudoTexture :
            begin
              HelpX1 := integer(Point2DList^[ ElementList^[j].Number[0]][x]);
              HelpY1 := integer(Point2DList^[ ElementList^[j].Number[0]][y]);
              HelpX2 := integer(Point2DList^[ ElementList^[j].Number[1]][x]);
              HelpY2 := integer(Point2DList^[ ElementList^[j].Number[1]][y]);

              if HelpX1 > HelpX2 then
                begin
                  Puffer := HelpX1;
                  HelpX1 := HelpX2;
                  HelpX2 := Puffer;
                end;
              if HelpY1 > HelpY2 then
                begin
                  Puffer := HelpY1;
                  HelpY1 := HelpY2;
                  HelpY2 := Puffer;
                end;

              HelpX2 := longint( HelpX2 ) - HelpX1;
              HelpY2 := longint( HelpY2 ) - HelpY1;

              if ( ( HelpX1 >= 0 ) and ( HelpX2 <= 639 ) and
                   ( HelpY1 >= 0 ) and ( HelpY2 <= 479 ) ) then
                PutSpriteScaled101h(
                  HelpX1,
                  HelpY1,
                  HelpX2,
                  HelpY2,
                  TextureList^[ ElementList^[j].Color[0] ].Data );
            end;
          PseudoTextureTrans :
            begin
              HelpX1 := integer(Point2DList^[ ElementList^[j].Number[0]][x]);
              HelpY1 := integer(Point2DList^[ ElementList^[j].Number[0]][y]);
              HelpX2 := integer(Point2DList^[ ElementList^[j].Number[1]][x]);
              HelpY2 := integer(Point2DList^[ ElementList^[j].Number[1]][y]);

              if HelpX1 > HelpX2 then
                begin
                  Puffer := HelpX1;
                  HelpX1 := HelpX2;
                  HelpX2 := Puffer;
                end;
              if HelpY1 > HelpY2 then
                begin
                  Puffer := HelpY1;
                  HelpY1 := HelpY2;
                  HelpY2 := Puffer;
                end;

              HelpX2 := longint( HelpX2 ) - HelpX1;
              HelpY2 := longint( HelpY2 ) - HelpY1;

              PutSpriteScaledTrans101h(
                HelpX1,
                HelpY1,
                HelpX2,
                HelpY2,
                ElementList^[j].Color[1], {zu versteckende Farbe}
                TextureList^[ ElementList^[j].Color[0] ].Data );
            end;
            {$ENDIF}
        else begin setvideomode($3); writeln('Unknown object to draw!'); halt(0); end;
      end;
    end;
end;


procedure GetWorldOrders( VAR World : PWorld3D;
                          StepRot,StepTra,StepDelta,
                          StepPlyTra,StepPlyRot : byte );
begin
  with World^ do
    begin
      {rot about x-axis}
      if key[kKEYPAD8] = 1 then Rot[X] := Rot[X] + StepRot;
      if key[kKEYPAD2] = 1 then Rot[X] := Rot[X] - StepRot;
      {rot about z-axis}
      if key[kKEYPAD4] = 1 then Rot[Z] := Rot[Z] + StepRot;
      if key[kKEYPAD6] = 1 then Rot[Z] := Rot[Z] - StepRot;
      {rot about y-axis}
      if key[kLARROW] = 1 then Rot[Y] := Rot[Y] + StepRot;
      if key[kRARROW] = 1 then Rot[Y] := Rot[Y] - StepRot;
      {tra on x-axis}
      if key[kD] = 1 then Tra[X] := Tra[X] + StepTra * PointAdj;
      if key[kA] = 1 then Tra[X] := Tra[X] - StepTra * PointAdj;
      {tra on y-axis}
      if key[kW] = 1 then Tra[Y] := Tra[Y] + StepTra * PointAdj;
      if key[kS] = 1 then Tra[Y] := Tra[Y] - StepTra * PointAdj;
      {tra on z-axis}
      if key[kDARROW] = 1 then Tra[Z] := Tra[Z] + StepTra * PointAdj;
      if key[kUARROW] = 1 then Tra[Z] := Tra[Z] - StepTra * PointAdj;
      {deltax7y move}
      if key[kJ] = 1 then DeltaX := DeltaX - StepDelta;
      if key[kL] = 1 then DeltaX := DeltaX + StepDelta;
      if key[kI] = 1 then DeltaY := DeltaY - StepDelta;
      if key[kK] = 1 then DeltaY := DeltaY + StepDelta;
      {translation of player}
      if key[kPGDN] = 1 then PlayerTra[X] := PlayerTra[X] - StepPlyTra * PointAdj;
      if key[kDEL]  = 1 then PlayerTra[X] := PlayerTra[X] + StepPlyTra * PointAdj;
      if key[kINS]  = 1 then PlayerTra[Y] := PlayerTra[Y] - StepPlyTra * PointAdj;
      if key[kPGUP] = 1 then PlayerTra[Y] := PlayerTra[Y] + StepPlyTra * PointAdj;
      if key[kHOME] = 1 then PlayerTra[Z] := PlayerTra[Z] - StepPlyTra * PointAdj;
      if key[kEND]  = 1 then PlayerTra[Z] := PlayerTra[Z] + StepPlyTra * PointAdj;
      {rotation of player}
      if key[kF] = 1 then PlayerRot[Y] := PlayerRot[Y] + StepPlyRot;
      if key[kH] = 1 then PlayerRot[Y] := PlayerRot[Y] - StepPlyRot;
      if key[kY] = 1 then PlayerRot[X] := PlayerRot[X] - StepPlyRot;
      if key[kR] = 1 then PlayerRot[X] := PlayerRot[X] + StepPlyRot;
      if key[kT] = 1 then PlayerRot[Z] := PlayerRot[Z] - StepPlyRot;
      if key[kG] = 1 then PlayerRot[Z] := PlayerRot[Z] + StepPlyRot;
    end;
end;

procedure GetPlayerOrders( VAR World : PWorld3D;
                           StepRot,StepTra,StepDelta,
                           StepPlyTra,StepPlyRot : byte;
                           Scaling : real
                            );
var
  Shift : boolean;

begin
  if ( key[kLEFTSHIFT] = 1 ) or
     ( key[kRIGHTSHIFT] = 1 ) then
     Shift := true else Shift := false;

  if Shift then StepPlyTra := StepPlyTra shl 1;
  {}
  with World^ do
    begin
      {vorwrts&rckwrts laufen}
      if key[kDARROW] = 1 then
        begin
          PlayerTra[x] := PlayerTra[x] -
            round ( StepPlyTra *
                    sin( PlayerRot[y] / PointAdj * Pi * 2 )
                    * PointAdj);
          PlayerTra[z] := PlayerTra[z] +
            round ( StepPlyTra *
                    cos( PlayerRot[y] / PointAdj * Pi * 2 )
                    * PointAdj);
        end;
      if Key[kUARROW] = 1 then
        begin
          PlayerTra[x] := PlayerTra[x] +
            round ( StepPlyTra *
                    sin( PlayerRot[y] / PointAdj * Pi * 2 )
                    * PointAdj);
          PlayerTra[z] := PlayerTra[z] -
            round ( StepPlyTra *
                    cos( PlayerRot[y] / PointAdj * Pi * 2 )
                    * PointAdj);
         end;
      {links & rechts drehen}
      if key[kLARROW] = 1 then PlayerRot[Y] := PlayerRot[Y] + StepPlyRot;
      if key[kRARROW] = 1 then PlayerRot[Y] := PlayerRot[Y] - StepPlyRot;
      {hoch runter bewegen}
      if key[kZ] = 1 then PlayerTra[y] := PlayerTra[y] - StepTra * PointAdj;
      if key[kX] = 1 then PlayerTra[y] := PlayerTra[y] + StepTra * PointAdj;
      {zoom in/out}
      if ( key[kY] = 1 ) and
        not Shift then Tra[Z] := Tra[Z] - StepTra * PointAdj;
      if ( key[kY] = 1 ) and
         Shift then Tra[Z] := Tra[Z] + StepTra * PointAdj;
      {turn left/right}
      if key[kO] = 1 then Rot[y] := Rot[Y] + StepPlyRot;
      if key[kP] = 1 then Rot[y] := Rot[Y] - StepPlyRot;
      {hoch runter/schauen}
      if key[kQ] = 1 then Winkel0 := Winkel0 + StepPlyRot;
      if key[kA] = 1 then Winkel0 := Winkel0 - StepPlyRot;
      PlayerRot[x] := round ( Winkel0 *
                              cos ( PlayerRot[y] / PointAdj * Pi * 2 ) );
{      Rot[z] := round ( Winkel0 *
                              sin ( PlayerRot[y] / PointAdj * Pi * 2 ) );}
      if key[kKEYPAD4] = 1 then PlayerRot[Y] := PlayerRot[Y] + StepPlyRot;
      if key[kKEYPAD6] = 1 then PlayerRot[Y] := PlayerRot[Y] - StepPlyRot;
      if key[kKEYPAD8] = 1 then PlayerRot[X] := PlayerRot[X] - StepPlyRot;
      if key[kKEYPAD2] = 1 then PlayerRot[X] := PlayerRot[X] + StepPlyRot;
      if key[kKEYPAD7] = 1 then PlayerRot[Z] := PlayerRot[Z] - StepPlyRot;
      if key[kKEYPAD9] = 1 then PlayerRot[Z] := PlayerRot[Z] + StepPlyRot;

    end;
end;


procedure DisplayVideo3DInfo;
begin
  writeln('Video3D-Information:');
  writeln('Internal floating point: ', PointAdj);
  writeln('world-const:');
  writeln('max. ', MaxVec2D    : 5, ' vectors');
  writeln('max. ', MaxElement  : 5, ' elements');
  writeln('max. ', MaxEdges    : 5, ' edges');
  writeln('max. ', MaxTextures : 5, ' textures');
end;

procedure DisplayWorldInfo(world : PWorld3d);
begin
  writeln('World-Information:');
  writeln('TraX-Z,RotX-Z :', World^.Tra[X] div pointadj,
                         ',',World^.Tra[Y] div pointadj,
                         ',',World^.Tra[Z] div pointadj,',',
                             World^.Rot[X],
                         ',',World^.Rot[Y],
                         ',',World^.Rot[Z]
                         );
  writeln('Vectors       :', World^.VectorCounter:5 ,' of',MaxVec2D:5);
  writeln('Elements      :', World^.ElementCounter:5,' of',MaxElement:5);
  writeln('Objects       :', World^.ObjectCounter:5 ,' of',MaxObject3D:5);
  writeln('Textures      :', World^.TextureCounter:5,' of',MaxTextures:5);
  writeln('Perspective-x     :', World^.deltax:5);
  writeln('Perspective-y     :', World^.deltay:5);
  writeln('Final scaling x   :', World^.FinalscalingX:5);
  writeln('Final scaling y   :', World^.FinalscalingY:5);
  writeln('Final scaling z   :', World^.FinalscalingZ:5);
end;

procedure DirectTraRelObject( VAR World : PWorld3d;
                              ObjNo : word;
                              DirectTra : T3D );
var
  i : longint;
begin
  with World^ do
    for i := ObjectList^[ ObjNo ].StartVector to
             ObjectList^[ ObjNo ].EndVector do
      VecAdd3d( VectorList^[i] , DirectTra , VectorList^[i] );
end;

procedure DirectRotObject( VAR World : PWorld3d;
                           ObjNo : word );
begin
  { not implemented yet }
end;

end.